#include "PublicKey.hpp"

PublicKey(const Bipoint<curvepoint_fp_t>& a, const Bipoint<twistpoint_fp2_t>& b, const Bipoint<curvepoint_fp_t>& c, const Bipoint<twistpoint_fp2_t>& d)
{
    set(a, b, c, d);
}

void set(const Bipoint<curvepoint_fp_t>& a, const Bipoint<twistpoint_fp2_t>& b, const Bipoint<curvepoint_fp_t>& c, const Bipoint<twistpoint_fp2_t>& d)
{
    a.makeaffine();
    b.makeaffine();
    c.makeaffine();
    d.makeaffine();

    bipoint_curvegen = a;
    bipoint_twistgen = b;
    
    bipoint_curve_groupelt = c;
    bipoint_twist_groupelt = d;
}

Bipoint<curvepoint_fp_t> PublicKey::get_bipoint_curvegen() const
{
    return bipoint_curvegen;
}

Bipoint<twistpoint_fp2_t> PublicKey::get_bipoint_twistgen() const
{
    return bipoint_twistgen;
}

Bipoint<curvepoint_fp_t> PublicKey::get_bipoint_curve_groupelt() const
{
    return bipoint_curve_groupelt;
}

Bipoint<twistpoint_fp2_t> PublicKey::get_bipoint_twist_groupelt() const
{
    return bipoint_twist_groupelt;
}
