#ifndef __HOMOMORPHIC_OPERATIONS_HPP
#define __HOMOMORPHIC_OPERATIONS_HPP

#include "Bipoint.hpp"
#include "Quadripoint.hpp"
#include "PublicKey.hpp"
#include "pairing.hpp"

Bipoint<curvepoint_fp_t> bgn_homomorphic_addition(const Bipoint<curvepoint_fp_t>& a, const Bipoint<curvepoint_fp_t>& b, const PublicKey& public_key);
Bipoint<twistpoint_fp2_t> bgn_homomorphic_addition(const Bipoint<twistpoint_fp2_t>& a, const Bipoint<twistpoint_fp2_t>& b, const PublicKey& public_key);
Quadripoint bgn_homomorphic_addition(const Quadripoint& a, const Quadripoint& b, const PublicKey& public_key);
Quadripoint bgn_homomorphic_multiplication(const Bipoint<curvepoint_fp_t>& a, const Bipoint<twistpoint_fp2_t>& b, const PublicKey& public_key);

#endif /* __HOMOMORPHIC_OPERATIONS_HPP */
